using System;

using BS.Shared;

namespace BeWo.Data.Entities
{
    public class FollowUp : BeWoEntityBase
    {
        public static string PropertyName_Employee = "Employee";

        public static string PropertyName_ExpirationDate = "ExpirationDate";

        public static string PropertyName_IsHandled = "IsHandled";

        public static string PropertyName_ObjectOid = "ObjectOid";

        public static string PropertyName_ObjectTid = "ObjectTid";

        public static string PropertyName_Responsible = "Responsible";

        private Employee _Employee;

        private DateTime? _ExpirationDate;

        private bool? _IsHandled;

        private long? _ObjectOid;

        private TableID _ObjectTid;

        private Employee _Responsible;

        public FollowUp()
        {
            this._Tid = TableID.FollowUp;
        }

        public virtual Employee Employee
        {
            get
            {
                return this._Employee;
            }

            set
            {
                if (this.AreDifferent(this._Employee, value))
                {
                    this._Employee = value;
                }
            }
        }

        public virtual DateTime? ExpirationDate
        {
            get
            {
                return this._ExpirationDate;
            }

            set
            {
                if (this.AreDifferent(this._ExpirationDate, value))
                {
                    this._ExpirationDate = value;
                }
            }
        }

        public virtual bool? IsHandled
        {
            get
            {
                return this._IsHandled;
            }

            set
            {
                if (this.AreDifferent(this._IsHandled, value))
                {
                    this._IsHandled = value;
                }
            }
        }

        public virtual long? ObjectOid
        {
            get
            {
                return this._ObjectOid;
            }

            set
            {
                if (this.AreDifferent(this._ObjectOid, value))
                {
                    this._ObjectOid = value;
                }
            }
        }

        public virtual TableID ObjectTid
        {
            get
            {
                return this._ObjectTid;
            }

            set
            {
                if (this._ObjectTid != value)
                {
                    this._ObjectTid = value;
                }
            }
        }

        public virtual Employee Responsible
        {
            get
            {
                return this._Responsible;
            }

            set
            {
                if (this.AreDifferent(this._Responsible, value))
                {
                    this._Responsible = value;
                }
            }
        }

        public override string ToString()
        {
            return this.Notice;
        }
    }
}